import 'package:interceptable/interceptable.dart';
import 'package:interceptable/src/runtime/contract/target.dart';
import 'package:interceptable/src/runtime/filter_chain.dart';

class SomeModel {
  int _a;

  int get a {
    return Interceptable.applyGetterInterceptor(this, SomeModel, "a", _a);
  }

  set a(int a) {
    _a = Interceptable.applySetterInterceptor(this, SomeModel, "a", a);
  }

  setA() {
    return Interceptable.applyMethodInterceptor(
        this, SomeModel, "setA", this._setA);
  }

  _setA() {
    this.a = 111;
  }
}

class TestGetterFilter implements Filter {
  @override
  Object execute(Target target, FilterChain filterChain) {
    if (target is GetterTarget) {
      return (filterChain.execute(target) as int) * 100;
    }

    return target.execute();
  }
}

void main() {
  // Generated
  Interceptable.addInterceptor(
    SomeModel,
    "a",
    new TestGetterFilter(),
  );
  Interceptable.addInterceptor(
    SomeModel,
    "a",
    new TestGetterFilter(),
  );
  // END: Generated

  print(DateTime.now().millisecondsSinceEpoch);
  //
  var someModel = SomeModel();
  someModel.a = 99;
  print(someModel.a);
  print(DateTime.now().millisecondsSinceEpoch);
  print("============");
  someModel.setA();
}
